import { FunctionalStore } from "../../types/common";
import { inject } from "vue";

type InjectType = 'root' | 'optional';

export function useInjector<T extends object>(func: FunctionalStore<T>, type?: InjectType) {
  const token = func.token;
  const root = func.root;

  switch(type) {
    default:      
      if(inject(token)) {
        return inject<T>(token)
      };
      if(root) return func.root;
      throw new Error(`状态钩子函数${func.name}未在上层组件通过调用useProvider提供`);
    case 'optional':
      if(!token) return null;
    case 'root':
      if(!func.root) func.root = func();      
      return func.root;
  }   
}