import { FunctionalStore } from "../../types/common";
import { provide } from "vue";

export function useProvider<T extends object>(func: FunctionalStore<T>): T {
  !func.token && (func.token = Symbol('functional store'));
    const depends = func();
    provide(func.token, depends);
    return depends;
}

export function useProviders(...funcs: FunctionalStore<any>[]) {
  funcs.forEach( func => {
    !func.token && (func.token = Symbol('functional store'));
    provide(func.token, func());
  });
}