import { Ref, ref, UnwrapRef } from "vue";

interface Payload {

}

export function useState<T>(state: T): [Ref<UnwrapRef<T>>, (param: UnwrapRef<T>) => void ] {

  const stateRef = ref(state);

  function setState(payload: UnwrapRef<T>): void;
  function setState(payload: (current: T) => T): void;
  function setState(payload): void {
    if(typeof payload === 'function') {
      stateRef.value = payload(stateRef.value) 
    } else {
      stateRef.value = payload
    }    
  } 

  return [stateRef, setState]
}
