import { watch } from "vue";
import { useInjector } from "../../../hooks/common/useInjector";
import { useRequest } from "../../../hooks/common/useRequest";
import { useState } from "../../../hooks/common/useState";
import { useAuthStore } from "../auth/useAuthStore";
import { useAgoraClient } from "./useAgoraClient";

export function useVideoCallStore() {

  const [isMini, setMiniState] = useState(false); 
  const [channelInfo, getChannelInfo, status] = useRequest<any>('/getAgoraToken', {}, {auto: false});
  const { user } = useInjector(useAuthStore);

  const agora = useAgoraClient();

  const joinChannel = (channel_id?: string) => {
    getChannelInfo({channel_id});
    watch( status, val => {
      if(val === 'success') {
        const token = channelInfo.value.agora_token;
        const cid   = channelInfo.value.channel_id;
        agora.joinChannel(token, cid, user.value.id); 
      }
    })    
  }

  return {
    isMini,
    streams: agora.streamList,
    action: {
      setMiniState,
      joinChannel
    }
  }

}
